package wordole;
/*
 * j-interop can be found at http://www.j-interop.org/
 * and it is an open source project
 *
 */
import java.net.UnknownHostException;
import org.jinterop.dcom.common.JIException;
import org.jinterop.dcom.common.JISystem;
import org.jinterop.dcom.core.IJIComObject;
import org.jinterop.dcom.core.JIComServer;
import org.jinterop.dcom.core.JIProgId;
import org.jinterop.dcom.core.JISession;
import org.jinterop.dcom.core.JIString;
import org.jinterop.dcom.core.JIVariant;
import org.jinterop.dcom.impls.JIObjectFactory;
import org.jinterop.dcom.impls.automation.IJIDispatch;

public class MSWord {

	private JIComServer comStub = null;

	private IJIDispatch dispatch = null;

	private IJIComObject unknown = null;

    private IJIDispatch PDF = null;

    private JIString PRINTER = null;

	public MSWord(String address, String[] args, IJIDispatch PDF, JIString PRINTER) throws JIException, UnknownHostException {

        this.PDF = PDF;
        this.PRINTER = PRINTER;

		JISession session = JISession.createSession(args[1], args[2], args[3]);
		session.useSessionSecurity(true);
		comStub = new JIComServer(JIProgId.valueOf("Word.Application"), address, session);
	}

	public void startWord() throws JIException {
		unknown = comStub.createInstance();
		dispatch = (IJIDispatch) JIObjectFactory.narrowObject(unknown.queryInterface(IJIDispatch.IID));
	}

	public void showWord() throws JIException {
		int dispId = dispatch.getIDsOfNames("Visible");
		JIVariant variant = new JIVariant(Boolean.FALSE);
		dispatch.put(dispId, variant);
        PDF.callMethod("LicenseOLEServer");
	}

	public void performOp() throws JIException, InterruptedException {

		/* JISystem config *
		 *
		 */
		JISystem.setJavaCoClassAutoCollection(true);



		System.out.println(((JIVariant) dispatch.get("Version")).getObjectAsString().getString());
		System.out.println(((JIVariant) dispatch.get("Path")).getObjectAsString().getString());
		JIVariant variant = dispatch.get("Documents");

		System.out.println("Open document...");
		IJIDispatch documents = (IJIDispatch) JIObjectFactory.narrowObject(variant.getObjectAsComObject());
		JIString filePath = new JIString("c:\\temp\\test.doc");
		JIVariant variant2[] = documents.callMethodA("open", new Object[] { filePath, JIVariant.OPTIONAL_PARAM(), JIVariant.OPTIONAL_PARAM(), JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() ,JIVariant.OPTIONAL_PARAM() , JIVariant.OPTIONAL_PARAM() });

		System.out.println("doc opened");
        //ActivePrinter
        dispatch.put("ActivePrinter", new Object[]{PRINTER});

		sleep(5);
		System.out.println("Get content...");
		IJIDispatch document = (IJIDispatch) JIObjectFactory.narrowObject(variant2[0].getObjectAsComObject());

        sleep(5);
        System.out.println("Printing...");
        document.callMethod("PrintOut", new Object[] {1});

		System.out.println("Closing document...");
		document.callMethod("Close");

	}

	private void sleep(int sec) throws InterruptedException {
		System.out.println("Sleeping "+sec+" second(s)...");
		Thread.sleep( (int)(sec  * 1000) );
	}

	/**
	 * @throws JIException
	 */
	public void quitAndDestroy() throws JIException {
		System.out.println("Quit...");
		dispatch.callMethod("Quit", new Object[] { new JIVariant(-1, true), JIVariant.OPTIONAL_PARAM(), JIVariant.OPTIONAL_PARAM() });
		JISession.destroySession(dispatch.getAssociatedSession());
	}

}
